<?php
// Set advanced debug options if user set any.
if ( ( isset( $_POST['skip_files'] ) ) && ( $_POST['skip_files'] == 'on' ) ) { $this->_options['skip_files'] = true; }
if ( ( isset( $_POST['skip_database_import'] ) ) && ( $_POST['skip_database_import'] == 'on' ) ) { $this->_options['skip_database_import'] = true; }
if ( ( isset( $_POST['skip_database_migration'] ) ) && ( $_POST['skip_database_migration'] == 'on' ) ) { $this->_options['skip_database_migration'] = true; }
if ( ( isset( $_POST['wipe_database'] ) ) && ( $_POST['wipe_database'] == 'on' ) ) { $this->_options['wipe_database'] = true; }
if ( ( isset( $_POST['skip_htaccess'] ) ) && ( $_POST['skip_htaccess'] == 'on' ) ) { $this->_options['skip_htaccess'] = true; }
if ( ( isset( $_POST['force_compatibility_medium'] ) ) && ( $_POST['force_compatibility_medium'] == 'on' ) ) { $this->_options['force_compatibility_medium'] = true; }
if ( ( isset( $_POST['force_compatibility_slow'] ) ) && ( $_POST['force_compatibility_slow'] == 'on' ) ) { $this->_options['force_compatibility_slow'] = true; }
if ( ( isset( $_POST['show_php_warnings'] ) ) && ( $_POST['show_php_warnings'] == 'on' ) ) { $this->_options['show_php_warnings'] = true; }
if ( ( isset( $_POST['file'] ) ) && ( $_POST['file'] != '' ) ) { $this->_options['file'] = $_POST['file']; }
if ( ( isset( $_POST['max_execution_time'] ) ) && ( is_numeric( $_POST['max_execution_time'] ) ) ) {
	$this->_options['max_execution_time'] = $_POST['max_execution_time'];
} else {
	$this->_options['max_execution_time'] = 30;
}
if ( ( isset( $_POST['log_level'] ) ) && ( $_POST['log_level'] != '' ) ) { $this->_options['log_level'] = $_POST['log_level']; }


// Set ZIP id (aka serial).
$this->_options['zip_id'] = $this->get_zip_id( $this->_options['file'] );

$failed = false; // Default value.


if ( true === $this->_options['skip_files'] ) { // Option to skip all file updating / extracting.
	$this->alert( 'Skipped extracting files based on debugging options.' );
	$this->log( 'Skipped extracting files based on debugging options.' );
} else {
	echo $this->status_box( 'Extracting backup ZIP file with ImportBuddy ' . $this->_version . '...' );
	$this->status( 'message', 'Unzipping into `' . ABSPATH . '`' );
	
	$backup_archive = ABSPATH . '/' . $this->_options['file'];
	$destination_directory = ABSPATH;
	
	$this->set_greedy_script_limits();
	
	// Set compatibility mode if defined.
	$compatibility_mode = false; // Default to no compatibility mode.
	if ( $this->_options['force_compatibility_medium'] != false ) {
		$compatibility_mode = 'ziparchive';
	} elseif ( $this->_options['force_compatibility_slow'] != false ) {
		$compatibility_mode = 'pclzip';
	}
	
	// Zip & Unzip library setup.
	require_once( ABSPATH . '/importbuddy/lib/zipbuddy/zipbuddy.php' );
	$_zipbuddy = new pluginbuddy_zipbuddy( ABSPATH, '', 'unzip' );
	$_zipbuddy->set_status_callback( array( &$this, 'status' ) );
	
	// Extract zip file & verify it worked.
	if ( true !== ( $result = $_zipbuddy->unzip( $backup_archive, $destination_directory, $compatibility_mode ) ) ) {
		$this->alert( 'Failed unzipping archive.' );
	} else { // Reported success; verify extraction.
		$this->_backupdata_file = ABSPATH . '/wp-content/uploads/temp_' . $this->_options['zip_id'] . '/backupbuddy_dat.php'; // Full backup dat file location
		$this->_backupdata_file_dbonly = ABSPATH . '/backupbuddy_dat.php'; // DB only dat file location
		$this->_backupdata_file_new = ABSPATH . '/wp-content/uploads/backupbuddy_temp/' . $this->_options['zip_id'] . '/backupbuddy_dat.php'; // Full backup dat file location
		if ( !file_exists( $this->_backupdata_file ) && !file_exists( $this->_backupdata_file_dbonly ) && !file_exists( $this->_backupdata_file_new ) ) {
			$failed = true;
			$this->alert( 'Error: Key files missing.', 'The unzip process reported success but the backup data file, backupbuddy_dat.php was not found in the extracted files. The unzip process either failed (most likely) or the zip file is not a proper BackupBuddy backup.', '9004' );
		}
	}
}

if ( false === $failed ) {
	$this->log( 'Success extracting Zip File "' . ABSPATH . '/' . $this->_options['file'] . '" into "' . ABSPATH . '".' );
	
	echo '<br><br><b>Files successfully extracted.</b>';
	echo '<form action="?step=3" method=post>';
	echo '<input type="hidden" name="options" value="' . htmlspecialchars( serialize( $this->_options ) ) . '" />';
	echo '<br><br><p style="text-align: center;"><input type="submit" name="submit" value="Next Step &raquo;" class="button" /></p>';
	echo '</form>';
} else {
	$this->alert( 'File extraction process did not complete successfully.', 'Unable to continue to next step. Manually extract the backup ZIP file and choose to "Skip File Extraction" from the advanced options on Step 1.', '9005' );
	echo '<p style="text-align: center;"><a href="http://pluginbuddy.com/tutorials/unzip-backup-zip-file-in-cpanel/">Click here for instructions on manual ZIP extraction as a work-around.</a></p>';
}
?>