<?php
// Set up backup data from the backupbuddy_dat.php.
$this->load_backup_dat();

if ( isset( $_POST['siteurl'] ) ) { $this->_options['siteurl'] = $_POST['siteurl']; }
if ( isset( $_POST['home'] ) ) {
	$this->_options['home'] = $_POST['home'];
} else {
	$this->_options['home'] = $_POST['siteurl'];
}

if ( isset( $_POST['db_server'] ) ) { $this->_options['db_server'] = $_POST['db_server']; }
if ( isset( $_POST['db_user'] ) ) { $this->_options['db_user'] = $_POST['db_user']; }
if ( isset( $_POST['db_password'] ) ) { $this->_options['db_password'] = $_POST['db_password']; }
if ( isset( $_POST['db_name'] ) ) { $this->_options['db_name'] = $_POST['db_name']; }
if ( isset( $_POST['db_prefix'] ) ) { $this->_options['db_prefix'] = $_POST['db_prefix']; }

$failed = false;

echo $this->status_box( 'Importing database content with ImportBuddy ' . $this->_version . '...' );

$this->set_greedy_script_limits();

// Migrate HTACCESS if not disabled.
if ( $this->_options['skip_htaccess'] == false ) {
	$this->migrate_htaccess();
}

// Import database unless disabled.
$db_continue = false;
if ( false === $this->_options['skip_database_import'] ) {
	// Wipe database if option was selected.
	if ( $this->_options['wipe_database'] == true ) {
		if ( isset( $_GET['db_continue'] ) && ( is_numeric( $_GET['db_continue'] ) ) ) {
			// do nothing
		} else { // dont wipe on substeps of db import.
			$this->status( 'message', 'Wiping existing database based on settings...' );
			$failed = !$this->wipe_database();
			if ( false !== $failed ) {
				$this->alert( 'Error', 'Unable to wipe database as configured in the settings.' );
			}
		}
	}
	
	// Sanitize db continuation value if needed.
	if ( isset( $_GET['db_continue'] ) && ( is_numeric( $_GET['db_continue'] ) ) ) {
		// do nothing
	} else {
		$_GET['db_continue'] = 0;
	}
	$import_result = $this->restore_database( $_GET['db_continue'] );
	if ( true === $import_result ) {
		$failed = false;
		//echo ' Done.<br>';
	} elseif ( $import_result === false ) { // Full failure.
		$failed = true;
		//echo ' Failed.<br>';
	} else { // Needs to chunk up DB import and continue...
		$failed = false;
		$db_continue = true;
		// Continue on query $import_result...
		$this->status( 'message', 'Next step will begin import on query ' . $import_result . '.' );
	}
} else {
	$failed = false;
	$this->status( 'message', 'Skipping database restore based on settings.' );
}


if ( false === $failed ) {
	echo '<br><br>';
	if ( $db_continue === true ) {
		echo '<div class="alert">';
		echo 'Your database was too large to import in one step and will be imported in chunks. Please continue the process until this step is finished.</div><br><br>';
		echo 'Please keep continuing until your database has fully imported. This may take a few steps.';
		echo '<form action="?step=5&db_continue=' . $import_result . '" method=post>';
		echo '<input type="hidden" name="options" value="' . htmlspecialchars( serialize( $this->_options ) ) . '" />';
		echo '<br><br><p style="text-align: center;"><input type="submit" name="submit" class="button" value="Continue Database Import &raquo" /></p>';
		echo '</form>';
	} else {
		echo '<b>Initial database import complete!</b><br><br>';
		echo 'Next the data in the database will be migrated to account for any file path or URL changes.';
		echo '<form action="?step=5" method=post>';
		echo '<input type="hidden" name="options" value="' . htmlspecialchars( serialize( $this->_options ) ) . '" />';
		echo '<br><br><p style="text-align: center;"><input type="submit" name="submit" class="button" value="Next Step &raquo" /></p>';
		echo '</form>';
	}
} else {
	echo '<br><b>Database import failed. Please use your back button to correct any errors.</b>';
}
?>